DistributedRegionMXBean (Apache Geode 2.0.2)
Description: declaration: package: org.apache.geode.management, interface: DistributedRegionMXBean

Package org.apache.geode.management

# Interface DistributedRegionMXBean

public interface DistributedRegionMXBean
MBean that provides access to information and management functionality for a `Region`.

Since:
  GemFire 7.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `float`
  `getAverageReads()`
  Returns the average number of read requests per second.
  `float`
  `getAverageWrites()`
  Returns the average number of write requests per second.
  `int`
  `getAvgBucketSize()`
  Returns the average number of entries in bucket.
  `int`
  `getBucketCount()`
  Returns the number of buckets on this member.
  `long`
  `getCacheListenerCallsAvgLatency()`
  Returns the average latency of a call to a `CacheListener`.
  `long`
  `getCacheWriterCallsAvgLatency()`
  Returns the average latency of a call to a `CacheWriter`.
  `float`
  `getCreatesRate()`
  Returns the number of creates per second.
  `float`
  `getDestroyRate()`
  Returns the number of destroys per second.
  `float`
  `getDiskReadsRate()`
  Returns the number of entries per second for all disks.
  `long`
  `getDiskTaskWaiting()`
  Deprecated.
  `long`
  `getDiskUsage()`
  Returns the total number of bytes used by all disks.
  `float`
  `getDiskWritesRate()`
  Returns the number of entries per second for all disks.
  `int`
  `getEmptyNodes()`
  Returns the number of members whose entry count is 0.
  `long`
  `getEntrySize()`
  Returns the aggregate entry size (in bytes) of all entries.
  `String`
  `getFullPath()`
  Returns the full path of the Region.
  `float`
  `getGetsRate()`
  Returns the number of gets per second.
  `long`
  `getHitCount()`
  Returns the number of times that a hit occurred.
  `float`
  `getHitRatio()`
  Returns the hit to miss ratio.
  `long`
  `getLastAccessedTime()`
  Returns the time of the most recent access.
  `long`
  `getLastModifiedTime()`
  Returns the time of the most recent modification.
  `float`
  `getLruDestroyRate()`
  Returns the rate of entries destroyed either by destroy cache operations or eviction.
  `float`
  `getLruEvictionRate()`
  Returns the entry eviction rate as triggered by the LRU policy.
  `int`
  `getMemberCount()`
  Returns the number of members hosting/using the Region.
  `String[]`
  `getMembers()`
  Returns a list of names/IDs of the members hosting the Region.
  `long`
  `getMissCount()`
  Returns the number of times that a cache miss occurred.
  `String`
  `getName()`
  Returns the name of the Region.
  `int`
  `getNumBucketsWithoutRedundancy()`
  Returns the number of buckets without full redundancy.
  `String`
  `getParentRegion()`
  Returns the name of the parent Region.
  `int`
  `getPrimaryBucketCount()`
  Returns the number of primary buckets on this member.
  `float`
  `getPutAllRate()`
  Returns the number of putAlls per second.
  `float`
  `getPutLocalRate()`
  Returns the number of local puts per second.
  `long`
  `getPutRemoteAvgLatency()`
  Returns the average latency for remote puts.
  `long`
  `getPutRemoteLatency()`
  Returns the latency for the most recent remote put.
  `float`
  `getPutRemoteRate()`
  Returns the number of remote puts per second.
  `float`
  `getPutsRate()`
  Returns the number of puts per second.
  `String`
  `getRegionType()`
  Returns the type (data policy) of the Region.
  `long`
  `getSystemRegionEntryCount()`
  Returns the number of entries in the Region.
  `int`
  `getTotalBucketSize()`
  Returns the total number of entries in all buckets.
  `long`
  `getTotalDiskEntriesInVM()`
  Returns the current number of entries held in memory.
  `long`
  `getTotalDiskWritesProgress()`
  Returns the current number of disk writes in progress.
  `long`
  `getTotalEntriesOnlyOnDisk()`
  Returns the current number of entries whose values are only on disk (not in memory).
  `boolean`
  `isGatewayEnabled()`
  Returns whether the Region sends data to a `GatewaySender`.
  `boolean`
  `isPersistentEnabled()`
  Returns whether persistence is enabled.
  `EvictionAttributesData`
  `listEvictionAttributes()`
  Returns the eviction attributes of the Region.
  `FixedPartitionAttributesData[]`
  `listFixedPartitionAttributesData()`
  Returns the fixed partition attributes of the Region.
  `MembershipAttributesData`
  `listMembershipAttributes()`
  Deprecated.
  this API is scheduled to be removed
  `PartitionAttributesData`
  `listPartitionAttributes()`
  Returns the partition attributes of the Region.
  `RegionAttributesData`
  `listRegionAttributes()`
  Returns the attributes of the Region.
  `String[]`
  `listSubRegionPaths(boolean recursive)`
  Returns a list of the names of the subregions.

- ## Method Details

  - ### getName

    String getName()
    Returns the name of the Region.
    Returns:
      the name of the Region

  - ### getMemberCount

    int getMemberCount()
    Returns the number of members hosting/using the Region.
    Returns:
      the number of members hosting/using the Region

  - ### getMembers

    String[] getMembers()
    Returns a list of names/IDs of the members hosting the Region.
    Returns:
      an array of names/IDs of the members hosting the Region

  - ### getRegionType

    String getRegionType()
    Returns the type (data policy) of the Region. CreateRegionCommand will use this attribute
    Returns:
      the type (data policy) of the Region

  - ### getFullPath

    String getFullPath()
    Returns the full path of the Region.
    Returns:
      the full path of the Region

  - ### getParentRegion

    String getParentRegion()
    Returns the name of the parent Region.
    Returns:
      the name of the parent Region

  - ### listSubRegionPaths

    String[] listSubRegionPaths(boolean recursive)
    Returns a list of the names of the subregions.
    Parameters:
      `recursive` - `true` to recursively traverse and find sub-regions.
    Returns:
      an array of the names of the subregions

  - ### listRegionAttributes

    RegionAttributesData listRegionAttributes()
    Returns the attributes of the Region.
    Returns:
      the attributes of the Region

  - ### listPartitionAttributes

    PartitionAttributesData listPartitionAttributes()
    Returns the partition attributes of the Region.
    Returns:
      the partition attributes of the Region

  - ### listFixedPartitionAttributesData

    FixedPartitionAttributesData[] listFixedPartitionAttributesData()
    Returns the fixed partition attributes of the Region.
    Returns:
      the fixed partition attributes of the Region

  - ### listEvictionAttributes

    EvictionAttributesData listEvictionAttributes()
    Returns the eviction attributes of the Region.
    Returns:
      the eviction attributes of the Region

  - ### listMembershipAttributes

    @Deprecated MembershipAttributesData listMembershipAttributes()
    Deprecated.
    this API is scheduled to be removed
    Returns the membership attributes of the Region.
    Returns:
      the membership attributes of the Region

  - ### getLastModifiedTime

    long getLastModifiedTime()
    Returns the time of the most recent modification. For partitioned region it will be -1. This feature is not supported for partitioned regions.
    Returns:
      the time of the most recent modification

  - ### getLastAccessedTime

    long getLastAccessedTime()
    Returns the time of the most recent access. For partitioned region it will be -1. This feature is not supported for partitioned regions.
    Returns:
      the time of the most recent access

  - ### getMissCount

    long getMissCount()
    Returns the number of times that a cache miss occurred. For partitioned region it will be -1. This feature is not supported for partitioned regions.
    Returns:
      the number of times that a cache miss occurred

  - ### getHitCount

    long getHitCount()
    Returns the number of times that a hit occurred. For partitioned region it will be -1. This feature is not supported for partitioned regions.
    Returns:
      the number of times that a hit occurred

  - ### getHitRatio

    float getHitRatio()
    Returns the hit to miss ratio. For partitioned region it will be -1. This feature is not supported for partitioned regions.
    Returns:
      the hit to miss ratio

  - ### getSystemRegionEntryCount

    long getSystemRegionEntryCount()
    Returns the number of entries in the Region.
    Returns:
      the number of entries in the Region

  - ### getGetsRate

    float getGetsRate()
    Returns the number of gets per second.
    Returns:
      the number of gets per second

  - ### getPutsRate

    float getPutsRate()
    Returns the number of puts per second.
    Returns:
      the number of puts per second

  - ### getCreatesRate

    float getCreatesRate()
    Returns the number of creates per second.
    Returns:
      the number of creates per second

  - ### getDestroyRate

    float getDestroyRate()
    Returns the number of destroys per second.
    Returns:
      the number of destroys per second

  - ### getPutAllRate

    float getPutAllRate()
    Returns the number of putAlls per second.
    Returns:
      the number of putAlls per second

  - ### getPutLocalRate

    float getPutLocalRate()
    Returns the number of local puts per second.
    Returns:
      the number of local puts per second

  - ### getPutRemoteRate

    float getPutRemoteRate()
    Returns the number of remote puts per second.
    Returns:
      the number of remote puts per second

  - ### getPutRemoteLatency

    long getPutRemoteLatency()
    Returns the latency for the most recent remote put.
    Returns:
      the latency for the most recent remote put

  - ### getPutRemoteAvgLatency

    long getPutRemoteAvgLatency()
    Returns the average latency for remote puts.
    Returns:
      the average latency for remote puts

  - ### getTotalEntriesOnlyOnDisk

    long getTotalEntriesOnlyOnDisk()
    Returns the current number of entries whose values are only on disk (not in memory). Entries may not exist in memory if they have been overflowed to disk or not yet been faulted in after a recovery.
    Returns:
      the current number of entries whose values are only on disk

  - ### getTotalDiskEntriesInVM

    long getTotalDiskEntriesInVM()
    Returns the current number of entries held in memory.
    Returns:
      the current number of entries held in memory

  - ### getDiskReadsRate

    float getDiskReadsRate()
    Returns the number of entries per second for all disks.
    Returns:
      the number of entries per second for all disks

  - ### getDiskWritesRate

    float getDiskWritesRate()
    Returns the number of entries per second for all disks.
    Returns:
      the number of entries per second for all disks

  - ### getDiskTaskWaiting

    @Deprecated long getDiskTaskWaiting()
    Deprecated.
    Returns the current number of disk tasks (op-log compaction, asynchronous recoveries, etc) that are waiting for a thread to run.
    Returns:
      the current number of disk tasks that are waiting for a thread to run

  - ### getTotalDiskWritesProgress

    long getTotalDiskWritesProgress()
    Returns the current number of disk writes in progress.
    Returns:
      the current number of disk writes in progress

  - ### getCacheWriterCallsAvgLatency

    long getCacheWriterCallsAvgLatency()
    Returns the average latency of a call to a `CacheWriter`.
    Returns:
      the average latency of a call to a `CacheWriter`

  - ### getCacheListenerCallsAvgLatency

    long getCacheListenerCallsAvgLatency()
    Returns the average latency of a call to a `CacheListener`.
    Returns:
      the average latency of a call to a `CacheListener`

  - ### getLruEvictionRate

    float getLruEvictionRate()
    Returns the entry eviction rate as triggered by the LRU policy.
    Returns:
      the entry eviction rate as triggered by the LRU policy

  - ### getLruDestroyRate

    float getLruDestroyRate()
    Returns the rate of entries destroyed either by destroy cache operations or eviction.
    Returns:
      the rate of entries destroyed either by destroy cache operations or eviction

  - ### getBucketCount

    int getBucketCount()
    Returns the number of buckets on this member. Only applicable for partitioned regions.
    Returns:
      the number of buckets on this member. Only applicable for partitioned regions

  - ### getPrimaryBucketCount

    int getPrimaryBucketCount()
    Returns the number of primary buckets on this member. Only applicable for partitioned regions.
    Returns:
      the number of primary buckets on this member. Only applicable for partitioned regions

  - ### getNumBucketsWithoutRedundancy

    int getNumBucketsWithoutRedundancy()
    Returns the number of buckets without full redundancy. Only applicable for partitioned regions.
    Returns:
      the number of buckets without full redundancy. Only applicable for partitioned regions

  - ### getTotalBucketSize

    int getTotalBucketSize()
    Returns the total number of entries in all buckets. Only applicable for partitioned regions.
    Returns:
      the total number of entries in all buckets. Only applicable for partitioned regions

  - ### getAvgBucketSize

    int getAvgBucketSize()
    Returns the average number of entries in bucket. Only applicable for partitioned regions.
    Returns:
      the average number of entries in bucket. Only applicable for partitioned regions

  - ### getDiskUsage

    long getDiskUsage()
    Returns the total number of bytes used by all disks.
    Returns:
      the total number of bytes used by all disks

  - ### getAverageReads

    float getAverageReads()
    Returns the average number of read requests per second.
    Returns:
      the average number of read requests per second

  - ### getAverageWrites

    float getAverageWrites()
    Returns the average number of write requests per second.
    Returns:
      the average number of write requests per second

  - ### isGatewayEnabled

    boolean isGatewayEnabled()
    Returns whether the Region sends data to a `GatewaySender`.
    Returns:
      True if the Region sends data, false otherwise.

  - ### isPersistentEnabled

    boolean isPersistentEnabled()
    Returns whether persistence is enabled.
    Returns:
      True if persistence is enabled, false otherwise.

  - ### getEntrySize

    long getEntrySize()
    Returns the aggregate entry size (in bytes) of all entries. For replicated regions, provides a value only if the eviction algorithm is set to `EvictionAlgorithm.LRU_MEMORY`. The entry size in this distributed context represents the sum total of memory used for data in the region across all members, so the reported value will include any redundant copies. All partitioned regions can report entry size, but the value also includes redundant entries and also counts the size of all the secondary entries in the node.
    Returns:
      the aggregate entry size (in bytes) of all entries

  - ### getEmptyNodes

    int getEmptyNodes()
    Returns the number of members whose entry count is 0.
    Returns:
      the number of members whose entry count is 0